//----------------------------------------------------------------------------
// QSGraph.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: QSGraph.pas
//----------------------------------------------------------------------------
#ifndef QSGraphHPP
#define QSGraphHPP
//----------------------------------------------------------------------------
#include <Printers.hpp>
#include <Pbrulers.hpp>
#include <Qspaint.hpp>
#include <WGraph.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Qsgraph
{
//-- type declarations -------------------------------------------------------
struct TWorldPoint
{
	double x;
	double y;
} ;

struct TPixelsPoint
{
	int x;
	int y;
} ;

struct TWLine
{
	double x1;
	double y1;
	double x2;
	double y2;
} ;

typedef int TShapeHandle;

enum TEdgeKind { ekBottom, ekRight, ekTop, ekLeft };

struct TEdge
{
	TEdgeKind edge;
	double xMin;
	double xMax;
	double yMin;
	double yMax;
} ;

typedef TWorldPoint TWorldPointArray[1000];

enum THRulerPosition { hrpTop, hrpBottom, hrpHidden };

enum TVRulerPosition { vrpLeft, vrpRight, vrpHidden };

enum TShapeKind { skLine, skEllipse, skCircle, skPolygon, skPolyline };

enum TFormingShape { fsNone, fsLine, fsEllipse, fsCircle, fsPolygon, fsPolyline };

class __declspec(delphiclass) TShape;
class __declspec(pascalimplementation) TShape : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	TWorldPointArray *WorldPointArray;
	int WorldPointCounter;
	int CurrentPointCounter;
	bool bFinished;
	void __fastcall DrawLine(void);
	void __fastcall DrawEllipse(void);
	void __fastcall DrawCircle(void);
	void __fastcall DrawPolygon(void);
	void __fastcall DrawPolyLine(void);
	bool __fastcall SelectedLine(double p0, double p1);
	bool __fastcall SelectedEllipse(double p0, double p1);
	bool __fastcall SelectedCircle(double p0, double p1);
	bool __fastcall SelectedPolygon(double p0, double p1);
	bool __fastcall SelectedPolyline(double p0, double p1);
	
public:
	Extctrls::TCustomPanel* Owner;
	TShapeKind Kind;
	Graphics::TPen* ShapePen;
	Graphics::TBrush* ShapeBrush;
	int ShapeOrder;
	void __fastcall Draw(void);
	void __fastcall DrawSelected(void);
	void __fastcall FirstPoint(double p0, double p1);
	void __fastcall NextPoint(double p0, double p1);
	bool __fastcall Selected(double p0, double p1);
	void __fastcall Move(double p0, double p1);
	void __fastcall Copy(void);
	void __fastcall Hide(void);
	__fastcall TShape(Extctrls::TCustomPanel* p0);
	__fastcall virtual ~TShape(void);
};

typedef TShape* TShapeArray[16383];

typedef TShapeArray *pTShapeArray;

class __declspec(delphiclass) TQSWorldGraph;
class __declspec(pascalimplementation) TQSWorldGraph : public Extctrls::TCustomPanel
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	double fXMinZoom;
	double fXMaxZoom;
	double fYMinZoom;
	double fYMaxZoom;
	bool bZoom;
	Graphics::TCanvas* fCurrentCanvas;
	Graphics::TCanvas* fOldCanvas;
	Pbrulers::TQSPBHRuler* fHRuler;
	Pbrulers::TQSPBVRuler* fVRuler;
	Qspaint::TQSPaintBox* fPaintBox;
	int fVersion;
	Classes::TNotifyEvent fOnPaint;
	TLengthUnits fLengthUnits;
	THRulerPosition fHRulerPosition;
	TVRulerPosition fVRulerPosition;
	int PreviousX;
	int PreviousY;
	double GeomXMax[101];
	double GeomXMin[101];
	double GeomYMax[101];
	double GeomYMin[101];
	int ZoomLevel;
	Controls::TMouseMoveEvent fOnMouseMove;
	Controls::TMouseEvent fOnMouseDown;
	Controls::TMouseEvent fOnMouseUp;
	Graphics::TFont* fHFont;
	Graphics::TFont* fVFont;
	double fHFontRelativeSize;
	double fVFontRelativeSize;
	bool bFirstTime;
	int fAvailableWidth;
	int fAvailableHeight;
	double fPrintMagnification;
	double fBasicPrintMagnification;
	bool bPrinting;
	TWorldPoint DistanceFirst;
	TWorldPoint DistanceLast;
	bool fDetailedPosition;
	int DetailedX;
	int DetailedY;
	TWLine WLine;
	Classes::TNotifyEvent FOnMouseEnter;
	Classes::TNotifyEvent FOnMouseLeave;
	int NumberOfShapes;
	int SelectedShape;
	bool bIgnorePaintBoxBm;
	bool fInteractiveApplication;
	double __fastcall GetXMin(void);
	void __fastcall SetXMin(double p0);
	double __fastcall GetXMax(void);
	void __fastcall SetXMax(double p0);
	double __fastcall GetYMin(void);
	void __fastcall SetYMin(double p0);
	double __fastcall GetYMax(void);
	void __fastcall SetYMax(double p0);
	void __fastcall SetProportional(bool p0);
	bool __fastcall GetProportional(void);
	Pbrulers::TQSPBHRuler* __fastcall CreateHRuler(void);
	Pbrulers::TQSPBVRuler* __fastcall CreateVRuler(void);
	Qspaint::TQSPaintBox* __fastcall CreatePaintBox(void);
	void __fastcall SetXIncrease(Qspaint::TXIncrease p0);
	Qspaint::TXIncrease __fastcall GetXIncrease(void);
	void __fastcall SetYIncrease(Qspaint::TYIncrease p0);
	Qspaint::TYIncrease __fastcall GetYIncrease(void);
	void __fastcall SetLengthUnits(Pbrulers::TLengthUnits p0);
	void __fastcall SetHRulerPosition(THRulerPosition p0);
	void __fastcall SetVRulerPosition(TVRulerPosition p0);
	void __fastcall SetHRulerDecimals(int p0);
	int __fastcall GetHRulerDecimals(void);
	void __fastcall SetVRulerDecimals(int p0);
	int __fastcall GetVRulerDecimals(void);
	void __fastcall DoOnMouseMove(System::TObject* p0, Classes::TShiftState p1, int p2, int p3);
	void __fastcall DoOnMouseDown(System::TObject* p0, Controls::TMouseButton p1, Classes::TShiftState 
		p2, int p3, int p4);
	void __fastcall DoOnMouseUp(System::TObject* p0, Controls::TMouseButton p1, Classes::TShiftState p2
		, int p3, int p4);
	void __fastcall SetBackgroundColor(Graphics::TColor p0);
	Graphics::TColor __fastcall GetBackGroundColor(void);
	void __fastcall SetHRulerFont(Graphics::TFont* p0);
	void __fastcall SetVRulerFont(Graphics::TFont* p0);
	int __fastcall GetAvailableWidth(void);
	int __fastcall GetAvailableHeight(void);
	void __fastcall SutherlandHodgmanPolygonClip(const TWorldPoint * p0, TWorldPoint * p1, int p2, int 
		&p3, const TEdge &QSGraph_);
	void __fastcall Output(const TWorldPoint &QSGraph_, int &p1, TWorldPoint * p2);
	bool __fastcall Inside(const TWorldPoint &QSGraph_, const TEdge &QSGraph_);
	TWorldPoint __fastcall Intersect(const TWorldPoint &QSGraph_, const TWorldPoint &QSGraph_, const TEdge 
		&QSGraph_);
	void __fastcall SetVersion(int p0);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &QSGraph_);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &QSGraph_);
	
protected:
	int StartX;
	int StartY;
	int EndX;
	int EndY;
	void __fastcall DrawLine(void);
	bool __fastcall InFrame(double p0, double p1);
	bool __fastcall LineSectionInterceptsYMinLine(double &p0);
	bool __fastcall LineSectionInterceptsYMaxLine(double &p0);
	bool __fastcall LineSectionInterceptsXMinLine(double &p0);
	bool __fastcall LineSectionInterceptsXMaxLine(double &p0);
	bool __fastcall PartOfFrameShows(double p0, double p1, double p2, double p3);
	bool __fastcall AllOfFrameShows(double p0, double p1, double p2, double p3);
	
public:
	int IPBx;
	int IPBy;
	double RPBx;
	double RPBy;
	Graphics::TPicture* JPEGPicture;
	Graphics::TPicture* BMPPicture;
	Graphics::TPicture* WMFPicture;
	Graphics::TPicture* GIFPicture;
	int XOffSetStart;
	TWorldPoint CurrentWorldPoint;
	TShapeArray *ShapeArray;
	virtual void __fastcall Paint(void);
	__fastcall virtual TQSWorldGraph(Classes::TComponent* p0);
	__fastcall virtual ~TQSWorldGraph(void);
	bool __fastcall LoadBMP( System::AnsiString p0);
	bool __fastcall LoadWMF( System::AnsiString p0);
	bool __fastcall LoadJPeg( System::AnsiString p0);
	void __fastcall BeginSelect(int p0, int p1);
	void __fastcall ContinueSelect(int p0, int p1);
	bool __fastcall EndSelect(int p0, int p1);
	void __fastcall BeginDistance(int p0, int p1, bool p2);
	double __fastcall ContinueDistance(int p0, int p1);
	double __fastcall EndDistance(int p0, int p1, bool p2);
	void __fastcall IncreaseZoom(double p0, double p1, double p2, double p3);
	void __fastcall DecreaseZoom(void);
	void __fastcall ResetZoom(void);
	TWorldPoint __fastcall Wxy(int p0, int p1);
	TPixelsPoint __fastcall PCxy(double p0, double p1);
	void __fastcall SetCursorTo(double p0, double p1);
	void __fastcall BeginPrinting(void);
	void __fastcall EndPrinting(void);
	void __fastcall WorldLineTo(double p0, double p1);
	void __fastcall WorldMoveTo(double p0, double p1);
	void __fastcall WorldArc(double p0, double p1, double p2, double p3, double p4, double p5, double p6
		, double p7);
	void __fastcall WorldEllipse(double p0, double p1, double p2, double p3);
	void __fastcall WorldQuad4(double p0, double p1, double p2, double p3, double p4, double p5, double 
		p6, double p7, Graphics::TColor p8, bool p9);
	void __fastcall WorldQuad8(double p0, double p1, double p2, double p3, double p4, double p5, double 
		p6, double p7, double p8, double p9, double p10, double p11, double p12, double p13, double p14, double 
		p15, Graphics::TColor p16, bool p17);
	void __fastcall WorldPolygon(Word p0, const TWorldPoint * p1, Graphics::TColor p2, Graphics::TColor 
		p3, bool p4);
	void __fastcall SquarePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall TrianglePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall CirclePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall EmptySquarePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall EmptyTrianglePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall EmptyCirclePoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall CrossPoint(int p0, double p1, double p2, Graphics::TColor p3);
	void __fastcall SetPen(Graphics::TColor p0, Graphics::TPenMode p1, Graphics::TPenStyle p2, int p3);
		
	void __fastcall ResetPen(void);
	void __fastcall RemoveDetailedPosition(void);
	void __fastcall DrawBitMap(Graphics::TGraphic* p0);
	void __fastcall StretchDrawBitMap(Graphics::TGraphic* p0);
	void __fastcall StretchPrintBitMap(Graphics::TGraphic* p0, double p1);
	void __fastcall PrintBitmap(Graphics::TBitmap* p0, int p1, int p2, double p3);
	void __fastcall PrintPicture(Graphics::TPicture* p0, int p1, int p2, double p3);
	void __fastcall PrintUserGraphic(double p0);
	void __fastcall ClipPolygon(const TWorldPoint * p0, int p1, TWorldPoint * p2, int &p3);
	int __fastcall AddShape(TShapeKind p0);
	void __fastcall BeginShape(double p0, double p1);
	bool __fastcall ContinueShape(double p0, double p1, bool p2);
	__property Canvas  = {read=fCurrentCanvas, write=fCurrentCanvas};
	
__published:
	__property Align ;
	__property Color ;
	__property Height ;
	__property Width ;
	__property Top ;
	__property Left ;
	__property Visible ;
	__property double XMin = {read=GetXMin, write=SetXMin};
	__property double XMax = {read=GetXMax, write=SetXMax};
	__property double YMin = {read=GetYMin, write=SetYMin};
	__property double YMax = {read=GetYMax, write=SetYMax};
	__property bool Proportional = {read=GetProportional, write=SetProportional, default=1};
	__property Qspaint::TXIncrease XIncrease = {read=GetXIncrease, write=SetXIncrease, nodefault};
	__property Qspaint::TYIncrease YIncrease = {read=GetYIncrease, write=SetYIncrease, default=0};
	__property Pbrulers::TLengthUnits LengthUnits = {read=fLengthUnits, write=SetLengthUnits, default=2
		};
	__property THRulerPosition HRulerPosition = {read=fHRulerPosition, write=SetHRulerPosition, default=0
		};
	__property TVRulerPosition VRulerPosition = {read=fVRulerPosition, write=SetVRulerPosition, default=0
		};
	__property int HRulerDecimals = {read=GetHRulerDecimals, write=SetHRulerDecimals, default=0};
	__property int VRulerDecimals = {read=GetVRulerDecimals, write=SetVRulerDecimals, default=0};
	__property Graphics::TColor BackgroundColor = {read=GetBackGroundColor, write=SetBackgroundColor, default=16777215
		};
	__property Graphics::TFont* HRulerFont = {read=fHFont, write=SetHRulerFont, nodefault};
	__property Graphics::TFont* VRulerFont = {read=fVFont, write=SetVRulerFont, nodefault};
	__property int AvailableWidth = {read=GetAvailableWidth, write=fAvailableWidth, nodefault};
	__property int AvailableHeight = {read=GetAvailableHeight, write=fAvailableHeight, nodefault};
	__property bool DetailedPosition = {read=fDetailedPosition, write=fDetailedPosition, nodefault};
	__property int Version = {read=fVersion, write=SetVersion, nodefault};
	__property bool InteractiveApplication = {read=fInteractiveApplication, write=fInteractiveApplication
		, nodefault};
	__property Font ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown  = {read=fOnMouseDown, write=fOnMouseDown};
	__property OnMouseMove  = {read=fOnMouseMove, write=fOnMouseMove};
	__property OnMouseUp  = {read=fOnMouseUp, write=fOnMouseUp};
	__property Classes::TNotifyEvent OnPaint = {read=fOnPaint, write=fOnPaint};
	__property Classes::TNotifyEvent OnMouseEnter = {read=FOnMouseEnter, write=FOnMouseEnter};
	__property Classes::TNotifyEvent OnMouseLeave = {read=FOnMouseLeave, write=FOnMouseLeave};
public:
	/* TWinControl.CreateParented */ __fastcall TQSWorldGraph(HWND ParentWindow) : Extctrls::TCustomPanel(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define gVersion (Word)(500)
extern int RegisteredID;

}	/* namespace Qsgraph */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qsgraph;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// QSGraph
