// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Qspaint.pas' rev: 3.00

#ifndef QspaintHPP
#define QspaintHPP
#include <Pbrulers.hpp>
#include <WGraph.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Qspaint
{
//-- type declarations -------------------------------------------------------
struct TWPoint
{
	double x;
	double y;
} ;

struct TPCPoint
{
	int x;
	int y;
} ;

typedef TWPoint TWPointArray[1000];

enum TXIncrease { LeftToRight, RightToLeft };

enum TYIncrease { BottomToTop, TopToBottom };

class DELPHICLASS TQSPaintBox;
class PASCALIMPLEMENTATION TQSPaintBox : public Extctrls::TPaintBox 
{
	typedef Extctrls::TPaintBox inherited;
	
private:
	double fXMinDesired;
	double fXMaxDesired;
	double fYMinDesired;
	double fYMaxDesired;
	double fXMinZoom;
	double fXMaxZoom;
	double fYMinZoom;
	double fYMaxZoom;
	bool bZoom;
	bool fProportional;
	void __fastcall SetXMin(double value);
	void __fastcall SetXMax(double value);
	void __fastcall SetYMin(double value);
	void __fastcall SetYMax(double value);
	
protected:
	Graphics::TColor ResetPenColor;
	TPenMode ResetPenMode;
	TPenStyle ResetPenStyle;
	int ResetPenwidth;
	
public:
	Classes::TNotifyEvent FOnPaint;
	double FXMin;
	double FXMax;
	double FYMin;
	double FYMax;
	TXIncrease XIncrease;
	TYIncrease YIncrease;
	bool BReDraw;
	Graphics::TCanvas* FCurrentCanvas;
	Graphics::TBitmap* bm;
	void __fastcall SetProportional(bool value);
	void __fastcall SetPrintProportional(bool value, double multiplier);
	virtual void __fastcall Paint(void);
	__fastcall virtual TQSPaintBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TQSPaintBox(void);
	void __fastcall Zoom(double x1, double y1, double x2, double y2);
	void __fastcall ResetZoom(void);
	TWPoint __fastcall Wxy(int PCx, int PCy);
	TPCPoint __fastcall PCxy(double wx, double wy);
	void __fastcall WorldLineTo(double Wx, double Wy);
	void __fastcall WorldMoveTo(double Wx, double Wy);
	void __fastcall WorldArc(double WX1, double WY1, double WX2, double WY2, double WX3, double WY3, double 
		WX4, double WY4);
	void __fastcall WorldEllipse(double WX1, double WY1, double WX2, double WY2);
	void __fastcall WorldQuad4(double Wx1, double Wy1, double Wx2, double Wy2, double Wx3, double Wy3, 
		double Wx4, double Wy4, Graphics::TColor color, bool bShowBoundary);
	void __fastcall WorldQuad8(double Wx1, double Wy1, double Wx2, double Wy2, double Wx3, double Wy3, 
		double Wx4, double Wy4, double Wx5, double Wy5, double Wx6, double Wy6, double Wx7, double Wy7, double 
		Wx8, double Wy8, Graphics::TColor color, bool bShowBoundary);
	void __fastcall WorldPolygon(Word NumberOfPoints, const TWPoint * Points, Graphics::TColor PenColor
		, Graphics::TColor FillColor, bool bShowBoundary);
	void __fastcall SquarePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall TrianglePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall CirclePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptySquarePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptyTrianglePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptyCirclePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall CrossPoint(int PointSize, double x, double y, Graphics::TColor Color);
	void __fastcall SetPen(Graphics::TColor PenColor, Graphics::TPenMode PenMode, Graphics::TPenStyle PenStyle
		, int PenWidth);
	void __fastcall ResetPen(void);
	void __fastcall DrawCrossAt(Graphics::TPenMode pm, int X, int Y);
	__property Canvas ;
	__property Align ;
	__property Color ;
	__property Height ;
	__property Width ;
	__property Top ;
	__property Left ;
	__property Visible ;
	__property double XMin = {read=fXMinDesired, write=SetXMin};
	__property double XMax = {read=fXMaxDesired, write=SetXMax};
	__property double YMin = {read=fYMinDesired, write=SetYMin};
	__property double YMax = {read=fYMaxDesired, write=SetYMax};
	__property bool Proportional = {read=fProportional, write=SetProportional, default=1};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property Classes::TNotifyEvent OnPaint = {read=FOnPaint, write=FOnPaint};
};

//-- var, const, procedure ---------------------------------------------------
#define MAX_POLYGON_POINTS (Word)(1000)

}	/* namespace Qspaint */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qspaint;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Qspaint
