// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QSGraph.pas' rev: 4.00

#ifndef QSGraphHPP
#define QSGraphHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Printers.hpp>	// Pascal unit
#include <Pbrulers.hpp>	// Pascal unit
#include <Qspaint.hpp>	// Pascal unit
#include <WGraph.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <jpeg.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qsgraph
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 4)
struct TWorldPoint
{
	double x;
	double y;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TPixelsPoint
{
	int x;
	int y;
} ;
#pragma pack(pop)

#pragma pack(push, 4)
struct TWLine
{
	double x1;
	double y1;
	double x2;
	double y2;
} ;
#pragma pack(pop)

typedef int TShapeHandle;

#pragma option push -b-
enum TEdgeKind { ekBottom, ekRight, ekTop, ekLeft };
#pragma option pop

#pragma pack(push, 4)
struct TEdge
{
	TEdgeKind edge;
	double xMin;
	double xMax;
	double yMin;
	double yMax;
} ;
#pragma pack(pop)

typedef TWorldPoint TWorldPointArray[1000];

#pragma option push -b-
enum THRulerPosition { hrpTop, hrpBottom, hrpHidden };
#pragma option pop

#pragma option push -b-
enum TVRulerPosition { vrpLeft, vrpRight, vrpHidden };
#pragma option pop

#pragma option push -b-
enum TShapeKind { skLine, skEllipse, skCircle, skPolygon, skPolyline };
#pragma option pop

#pragma option push -b-
enum TFormingShape { fsNone, fsLine, fsEllipse, fsCircle, fsPolygon, fsPolyline };
#pragma option pop

class DELPHICLASS TShape;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TShape : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TWorldPoint *WorldPointArray;
	int WorldPointCounter;
	int CurrentPointCounter;
	bool bFinished;
	void __fastcall DrawLine(void);
	void __fastcall DrawEllipse(void);
	void __fastcall DrawCircle(void);
	void __fastcall DrawPolygon(void);
	void __fastcall DrawPolyLine(void);
	bool __fastcall SelectedLine(double x, double y);
	bool __fastcall SelectedEllipse(double x, double y);
	bool __fastcall SelectedCircle(double x, double y);
	bool __fastcall SelectedPolygon(double x, double y);
	bool __fastcall SelectedPolyline(double x, double y);
	
public:
	Extctrls::TCustomPanel* Owner;
	TShapeKind Kind;
	Graphics::TPen* ShapePen;
	Graphics::TBrush* ShapeBrush;
	int ShapeOrder;
	void __fastcall Draw(void);
	void __fastcall DrawSelected(void);
	void __fastcall FirstPoint(double x, double y);
	void __fastcall NextPoint(double x, double y);
	bool __fastcall Selected(double x, double y);
	void __fastcall Move(double x, double y);
	void __fastcall Copy(void);
	void __fastcall Hide(void);
	__fastcall TShape(Extctrls::TCustomPanel* aOwner);
	__fastcall virtual ~TShape(void);
};

#pragma pack(pop)

typedef TShape* TShapeArray[16383];

typedef TShape* *pTShapeArray;

class DELPHICLASS TQSWorldGraph;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TQSWorldGraph : public Extctrls::TCustomPanel 
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	double fXMinZoom;
	double fXMaxZoom;
	double fYMinZoom;
	double fYMaxZoom;
	bool bZoom;
	Graphics::TCanvas* fCurrentCanvas;
	Graphics::TCanvas* fOldCanvas;
	Pbrulers::TQSPBHRuler* fHRuler;
	Pbrulers::TQSPBVRuler* fVRuler;
	Qspaint::TQSPaintBox* fPaintBox;
	int fVersion;
	Classes::TNotifyEvent fOnPaint;
	Pbrulers::TLengthUnits fLengthUnits;
	THRulerPosition fHRulerPosition;
	TVRulerPosition fVRulerPosition;
	int PreviousX;
	int PreviousY;
	double GeomXMax[101];
	double GeomXMin[101];
	double GeomYMax[101];
	double GeomYMin[101];
	int ZoomLevel;
	Controls::TMouseMoveEvent fOnMouseMove;
	Controls::TMouseEvent fOnMouseDown;
	Controls::TMouseEvent fOnMouseUp;
	Graphics::TFont* fHFont;
	Graphics::TFont* fVFont;
	double fHFontRelativeSize;
	double fVFontRelativeSize;
	bool bFirstTime;
	int fAvailableWidth;
	int fAvailableHeight;
	double fPrintMagnification;
	double fBasicPrintMagnification;
	bool bPrinting;
	TWorldPoint DistanceFirst;
	TWorldPoint DistanceLast;
	bool fDetailedPosition;
	int DetailedX;
	int DetailedY;
	TWLine WLine;
	Classes::TNotifyEvent FOnMouseEnter;
	Classes::TNotifyEvent FOnMouseLeave;
	int NumberOfShapes;
	int SelectedShape;
	bool bIgnorePaintBoxBm;
	bool fInteractiveApplication;
	double __fastcall GetXMin(void);
	void __fastcall SetXMin(double value);
	double __fastcall GetXMax(void);
	void __fastcall SetXMax(double value);
	double __fastcall GetYMin(void);
	void __fastcall SetYMin(double value);
	double __fastcall GetYMax(void);
	void __fastcall SetYMax(double value);
	void __fastcall SetProportional(bool value);
	bool __fastcall GetProportional(void);
	Pbrulers::TQSPBHRuler* __fastcall CreateHRuler(void);
	Pbrulers::TQSPBVRuler* __fastcall CreateVRuler(void);
	Qspaint::TQSPaintBox* __fastcall CreatePaintBox(void);
	void __fastcall SetXIncrease(Qspaint::TXIncrease value);
	Qspaint::TXIncrease __fastcall GetXIncrease(void);
	void __fastcall SetYIncrease(Qspaint::TYIncrease value);
	Qspaint::TYIncrease __fastcall GetYIncrease(void);
	void __fastcall SetLengthUnits(Pbrulers::TLengthUnits value);
	void __fastcall SetHRulerPosition(THRulerPosition value);
	void __fastcall SetVRulerPosition(TVRulerPosition value);
	void __fastcall SetHRulerDecimals(int value);
	int __fastcall GetHRulerDecimals(void);
	void __fastcall SetVRulerDecimals(int value);
	int __fastcall GetVRulerDecimals(void);
	void __fastcall DoOnMouseMove(System::TObject* Sender, Classes::TShiftState Shift, int X, int Y);
	void __fastcall DoOnMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	void __fastcall DoOnMouseUp(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	void __fastcall SetBackgroundColor(Graphics::TColor value);
	Graphics::TColor __fastcall GetBackGroundColor(void);
	void __fastcall SetHRulerFont(Graphics::TFont* value);
	void __fastcall SetVRulerFont(Graphics::TFont* value);
	int __fastcall GetAvailableWidth(void);
	int __fastcall GetAvailableHeight(void);
	void __fastcall SutherlandHodgmanPolygonClip(const TWorldPoint * inVertexArray, TWorldPoint * outVertexArray
		, int inLength, int &outLength, const TEdge &clipBoundary);
	void __fastcall Output(const TWorldPoint &newVertex, int &outLength, TWorldPoint * outVertexArray);
		
	bool __fastcall Inside(const TWorldPoint &testVertex, const TEdge &clipBoundary);
	TWorldPoint __fastcall Intersect(const TWorldPoint &first, const TWorldPoint &second, const TEdge &
		clipBoundary);
	void __fastcall SetVersion(int value);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Message);
	
protected:
	int StartX;
	int StartY;
	int EndX;
	int EndY;
	void __fastcall DrawLine(void);
	bool __fastcall InFrame(double x1, double y1);
	bool __fastcall LineSectionInterceptsYMinLine(double &x0);
	bool __fastcall LineSectionInterceptsYMaxLine(double &x0);
	bool __fastcall LineSectionInterceptsXMinLine(double &y0);
	bool __fastcall LineSectionInterceptsXMaxLine(double &y0);
	bool __fastcall PartOfFrameShows(double wx1, double wy1, double wx2, double wy2);
	bool __fastcall AllOfFrameShows(double wx1, double wy1, double wx2, double wy2);
	
public:
	int IPBx;
	int IPBy;
	double RPBx;
	double RPBy;
	Graphics::TPicture* JPEGPicture;
	Graphics::TPicture* BMPPicture;
	Graphics::TPicture* WMFPicture;
	Graphics::TPicture* GIFPicture;
	int XOffSetStart;
	TWorldPoint CurrentWorldPoint;
	TShape* *ShapeArray;
	virtual void __fastcall Paint(void);
	__fastcall virtual TQSWorldGraph(Classes::TComponent* AOwner);
	__fastcall virtual ~TQSWorldGraph(void);
	bool __fastcall LoadBMP(AnsiString FileName);
	bool __fastcall LoadWMF(AnsiString FileName);
	bool __fastcall LoadJPeg(AnsiString FileName);
	void __fastcall BeginSelect(int bx, int by);
	void __fastcall ContinueSelect(int cx, int cy);
	bool __fastcall EndSelect(int ex, int ey);
	void __fastcall BeginDistance(int bx, int by, bool bRePaint);
	double __fastcall ContinueDistance(int cx, int cy);
	double __fastcall EndDistance(int ex, int ey, bool bDrawDistanceLine);
	void __fastcall IncreaseZoom(double x1, double y1, double x2, double y2);
	void __fastcall DecreaseZoom(void);
	void __fastcall ResetZoom(void);
	TWorldPoint __fastcall Wxy(int PCx, int PCy);
	TPixelsPoint __fastcall PCxy(double wx, double wy);
	void __fastcall SetCursorTo(double wx, double wy);
	void __fastcall BeginPrinting(void);
	void __fastcall EndPrinting(void);
	void __fastcall WorldLineTo(double Wx, double Wy);
	void __fastcall WorldMoveTo(double Wx, double Wy);
	void __fastcall WorldArc(double WX1, double WY1, double WX2, double WY2, double WX3, double WY3, double 
		WX4, double WY4);
	void __fastcall WorldEllipse(double WX1, double WY1, double WX2, double WY2);
	void __fastcall WorldQuad4(double Wx1, double Wy1, double Wx2, double Wy2, double Wx3, double Wy3, 
		double Wx4, double Wy4, Graphics::TColor color, bool bShowBoundary);
	void __fastcall WorldQuad8(double Wx1, double Wy1, double Wx2, double Wy2, double Wx3, double Wy3, 
		double Wx4, double Wy4, double Wx5, double Wy5, double Wx6, double Wy6, double Wx7, double Wy7, double 
		Wx8, double Wy8, Graphics::TColor color, bool bShowBoundary);
	void __fastcall WorldPolygon(Word NumberOfPoints, const TWorldPoint * Points, Graphics::TColor PenColor
		, Graphics::TColor FillColor, bool bShowBoundary);
	void __fastcall SquarePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall TrianglePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall CirclePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptySquarePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptyTrianglePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall EmptyCirclePoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall CrossPoint(int PointSize, double x, double y, Graphics::TColor color);
	void __fastcall SetPen(Graphics::TColor PenColor, Graphics::TPenMode PenMode, Graphics::TPenStyle PenStyle
		, int PenWidth);
	void __fastcall ResetPen(void);
	void __fastcall RemoveDetailedPosition(void);
	void __fastcall DrawBitMap(Graphics::TGraphic* bm);
	void __fastcall StretchDrawBitMap(Graphics::TGraphic* bm);
	void __fastcall StretchPrintBitMap(Graphics::TGraphic* bm, double Magnification);
	void __fastcall PrintBitmap(Graphics::TBitmap* Bitmap, int X, int Y, double Magnification);
	void __fastcall PrintPicture(Graphics::TPicture* Picture, int X, int Y, double Magnification);
	void __fastcall PrintUserGraphic(double Magnification);
	void __fastcall ClipPolygon(const TWorldPoint * inVertexArray, int inLength, TWorldPoint * outVertexArray
		, int &outLength);
	int __fastcall AddShape(TShapeKind ShapeKind);
	void __fastcall BeginShape(double x, double y);
	bool __fastcall ContinueShape(double x, double y, bool done);
	__property Canvas  = {read=fCurrentCanvas, write=fCurrentCanvas};
	
__published:
	__property Align ;
	__property Color ;
	__property Height ;
	__property Width ;
	__property Top ;
	__property Left ;
	__property Visible ;
	__property double XMin = {read=GetXMin, write=SetXMin};
	__property double XMax = {read=GetXMax, write=SetXMax};
	__property double YMin = {read=GetYMin, write=SetYMin};
	__property double YMax = {read=GetYMax, write=SetYMax};
	__property bool Proportional = {read=GetProportional, write=SetProportional, default=1};
	__property Qspaint::TXIncrease XIncrease = {read=GetXIncrease, write=SetXIncrease, nodefault};
	__property Qspaint::TYIncrease YIncrease = {read=GetYIncrease, write=SetYIncrease, default=0};
	__property Pbrulers::TLengthUnits LengthUnits = {read=fLengthUnits, write=SetLengthUnits, default=2
		};
	__property THRulerPosition HRulerPosition = {read=fHRulerPosition, write=SetHRulerPosition, default=0
		};
	__property TVRulerPosition VRulerPosition = {read=fVRulerPosition, write=SetVRulerPosition, default=0
		};
	__property int HRulerDecimals = {read=GetHRulerDecimals, write=SetHRulerDecimals, default=0};
	__property int VRulerDecimals = {read=GetVRulerDecimals, write=SetVRulerDecimals, default=0};
	__property Graphics::TColor BackgroundColor = {read=GetBackGroundColor, write=SetBackgroundColor, default=16777215
		};
	__property Graphics::TFont* HRulerFont = {read=fHFont, write=SetHRulerFont};
	__property Graphics::TFont* VRulerFont = {read=fVFont, write=SetVRulerFont};
	__property int AvailableWidth = {read=GetAvailableWidth, write=fAvailableWidth, nodefault};
	__property int AvailableHeight = {read=GetAvailableHeight, write=fAvailableHeight, nodefault};
	__property bool DetailedPosition = {read=fDetailedPosition, write=fDetailedPosition, nodefault};
	__property int Version = {read=fVersion, write=SetVersion, nodefault};
	__property bool InteractiveApplication = {read=fInteractiveApplication, write=fInteractiveApplication
		, nodefault};
	__property Font ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown  = {read=fOnMouseDown, write=fOnMouseDown};
	__property OnMouseMove  = {read=fOnMouseMove, write=fOnMouseMove};
	__property OnMouseUp  = {read=fOnMouseUp, write=fOnMouseUp};
	__property Classes::TNotifyEvent OnPaint = {read=fOnPaint, write=fOnPaint};
	__property Classes::TNotifyEvent OnMouseEnter = {read=FOnMouseEnter, write=FOnMouseEnter};
	__property Classes::TNotifyEvent OnMouseLeave = {read=FOnMouseLeave, write=FOnMouseLeave};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TQSWorldGraph(HWND ParentWindow) : Extctrls::TCustomPanel(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Word gVersion = 0x1f4;
extern PACKAGE int RegisteredID;

}	/* namespace Qsgraph */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qsgraph;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QSGraph
